Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/UpdateCounters.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/UpdateCounters.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/UpdateCounters.cpp	(revision 12878)
@@ -9,5 +9,5 @@
 #endif
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../shared/shared.h"
 #include "../../include/include.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void NodalValuex( double* pnodalvalue, int natureofdataenum,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units){
+void NodalValuex( IssmDouble* pnodalvalue, int natureofdataenum,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units){
 
 	extern int my_rank;
@@ -16,5 +16,5 @@
 	int index;
 	Element* element=NULL;
-	double value;
+	IssmDouble value;
 	int found;
 	int sumfound;
@@ -38,5 +38,5 @@
 	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
-	if(!sumfound)_error_("%s%i%s%s","could not find element with vertex with id",index," to compute nodal value ",EnumToStringx(natureofdataenum));
+	if(!sumfound)_error2_("could not find element with vertex with id" << index << " to compute nodal value " << EnumToStringx(natureofdataenum));
 	#endif
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.h	(revision 12878)
@@ -7,8 +7,8 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
-void NodalValuex( double* pnodalvalue, int natureofdataenum,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
+void NodalValuex( IssmDouble* pnodalvalue, int natureofdataenum,Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,bool process_units);
 
 #endif  /* _NODALVALUEX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/NodeConnectivityx/NodeConnectivityx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/NodeConnectivityx/NodeConnectivityx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/NodeConnectivityx/NodeConnectivityx.cpp	(revision 12878)
@@ -37,5 +37,5 @@
 
 	/*Allocate connectivity: */
-	connectivity=(double*)xcalloc(nods*width,sizeof(double));
+	connectivity=xNewZeroInit<double>(nods*width);
 
 	/*Go through all elements, and for each elements, plug into the connectivity, all the nodes. 
@@ -71,5 +71,5 @@
 	 * warn the user to increase the connectivity width: */
 	for(i=0;i<nods;i++){
-		if (*(connectivity+width*i+maxels)>maxels)_error_("%s%g%s"," max connectivity width reached (",*(connectivity+width*i+maxels),")! increase width of connectivity table");
+		if (*(connectivity+width*i+maxels)>maxels)_error2_("max connectivity width reached (" << *(connectivity+width*i+maxels) << ")! increase width of connectivity table");
 	}
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/NodesDofx/NodesDofx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/NodesDofx/NodesDofx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/NodesDofx/NodesDofx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Orthx/Orthx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Orthx/Orthx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Orthx/Orthx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _ORTHX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../include/include.h"
 #include "../../shared/shared.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 12878)
@@ -14,7 +14,7 @@
 #include "../../Container/Container.h"
 #include "../../io/io.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 		
-void OutputResultsx(                    Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Results* results){
+void OutputResultsx(Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Results* results){
 
 	extern int  my_rank;
@@ -46,5 +46,5 @@
 		EnumToStringx(&solutiontypestring,solutiontype);
 		results->AddObject(new StringExternalResult(results->Size()+1,SolutionTypeEnum,solutiontypestring,1,0));
-		xfree((void**)&solutiontypestring);
+		xDelete<char>(solutiontypestring);
 	}
 
@@ -68,5 +68,5 @@
 			fid=pfopen(cpu_outputfilename ,"wb");
 		}
-		xfree((void**)&outputfilename);
+		xDelete<char>(outputfilename);
 		
 		/*Add file pointer in parameters for further calls to OutputResultsx: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 12878)
@@ -10,4 +10,6 @@
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
+
+#include <cstring>
 
 #include "./ParsePetscOptionsx.h"
@@ -25,5 +27,5 @@
 
 	/*intermediary: */
-	double* analyses=NULL;
+	IssmDouble* analyses=NULL;
 	char** strings=NULL;
 	int numanalyses;
@@ -46,6 +48,6 @@
 
 		/*Now, allocate analyses and strings: */
-		analyses=(double*)xmalloc(numanalyses*sizeof(double));
-		strings=(char**)xmalloc(numanalyses*sizeof(char*));
+		analyses=xNew<IssmDouble>(numanalyses);
+		strings=xNew<char*>(numanalyses);
 		for(i=0;i<numanalyses;i++)strings[i]=NULL; 
 
@@ -68,6 +70,6 @@
 			to the already existing options*/
 				if(strings[numanalyses-1]==NULL){
-					string=(char*)xmalloc((strlen(line)+1)*sizeof(char)); 
-					memcpy(string,line,(strlen(line)+1)*sizeof(char));
+					string=xNew<char>((strlen(line)+1)); 
+					xMemCpy<char>(string,line,(strlen(line)+1));
 
 					strings[numanalyses-1]=string;
@@ -75,16 +77,16 @@
 				else{
 					string=strings[numanalyses-1];
-					newstring=(char*)xmalloc((strlen(line)+1)*sizeof(char));
-					memcpy(newstring,line,(strlen(line)+1)*sizeof(char));
+					newstring=xNew<char>((strlen(line)+1));
+					xMemCpy<char>(newstring,line,(strlen(line)+1));
 
 					/*concatenate:*/
-					catstring=(char*)xmalloc((strlen(string)+1+strlen(newstring)+1+1)*sizeof(char)); //fit in a space " "
-					memcpy(catstring,string,(strlen(string)+1)*sizeof(char));
+					catstring=xNew<char>(strlen(string)+1+strlen(newstring)+1+1); //fit in a space " "
+					xMemCpy<char>(catstring,string,(strlen(string)+1));
 
 					strcat(catstring," ");
 					strcat(catstring,newstring);
 					strings[numanalyses-1]=catstring;
-					xfree((void**)&newstring);
-					xfree((void**)&string);
+					xDelete<char>(newstring);
+					xDelete<char>(string);
 				}
 			}
@@ -96,6 +98,6 @@
 	MPI_Bcast(&numanalyses,1,MPI_INT,0,MPI_COMM_WORLD);
 	if(my_rank!=0){
-		analyses=(double*)xmalloc(numanalyses*sizeof(double));
-		strings=(char**)xmalloc(numanalyses*sizeof(char*));
+		analyses=xNew<IssmPDouble>(numanalyses);
+		strings=xNew<char*>(numanalyses);
 	}
 	MPI_Bcast(analyses,numanalyses,MPI_DOUBLE,0,MPI_COMM_WORLD);
@@ -104,10 +106,10 @@
 		char* string=strings[i];
 		if(my_rank==0){
-			if(string==NULL) _error_("PETSc options for analysis %s have been declared but were not found",EnumToStringx((int)analyses[i]));
+			if(string==NULL) _error2_("PETSc options for analysis " << EnumToStringx(reCast<int>(analyses[i])) << " have been declared but were not found");
 		}
 		if(my_rank==0)stringlength=(strlen(string)+1)*sizeof(char);
 		#ifdef _HAVE_MPI_
 		MPI_Bcast(&stringlength,1,MPI_INT,0,MPI_COMM_WORLD);
-		if(my_rank!=0)string=(char*)xmalloc(stringlength);
+		if(my_rank!=0)string=xNew<char>(stringlength);
 		MPI_Bcast(string,stringlength,MPI_CHAR,0,MPI_COMM_WORLD);
 		if(my_rank!=0)strings[i]=string;
@@ -120,8 +122,7 @@
 
 	/*Clean up and return*/
-	for(i=0;i<numanalyses;i++) xfree((void**)&strings[i]);
-	xfree((void**)&strings);
-	xfree((void**)&analyses);
+	for(i=0;i<numanalyses;i++) xDelete<char>(strings[i]);
+	xDelete<char*>(strings);
+	xDelete<IssmDouble>(analyses);
 	return;
 }
-
Index: issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsx.h	(revision 12878)
@@ -8,5 +8,5 @@
 
 #include "../../shared/shared.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsxt.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsxt.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/PointCloudFindNeighborsx/PointCloudFindNeighborsxt.cpp	(revision 12878)
@@ -39,5 +39,5 @@
 
 	/*allocate: */
-	already=(bool*)xcalloc(nods,sizeof(bool));
+	already=xNewZeroInit<bool>(nods);
 
 	/*partition loop across threads: */
@@ -45,10 +45,9 @@
 
 	/*Loop over the nodes*/
-	if (my_thread==0) printf("      loop progress:   %5.2lf %%",0.0);
-
 	for (i=i0;i<i1;i++){
 
 		/*display current iteration*/
-		if (my_thread==0 && fmod((double)i,(double)100)==0) printf("\b\b\b\b\b\b\b%5.2lf %%",(double)i/nods*100*num_threads);
+		if (my_thread==0 && fmod((double)i,(double)100)==0)
+		 _printString_("\r      loop progress: "<<setw(6)<<setprecision(2)<<double(i-i0)/double(i1-i0)*100<<"%");
 
 		distance=mindistance+100; //make sure initialization respects min distance criterion.
@@ -70,8 +69,9 @@
 		}
 	}
-	if (my_thread==0) printf("\b\b\b\b\b\b\b%5.2lf %%\n",100.0);
+	if (my_thread==0)
+	 _printLine_("\r      loop progress: "<<fixed<<setw(6)<<setprecision(2)<<100.<<"%");
 
 	/*Free ressources:*/
-	xfree((void**)&already);
+	xDelete<bool>(already);
 	
 	return NULL;
Index: issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp	(revision 12878)
@@ -23,27 +23,23 @@
 
   int    i, it, jj, itm;
-  double DT = 0.02, sigfac, snormfac;
-  double signorm = 5.5;      // signorm : sigma of the temperature distribution for a normal day 
-  double siglim;       // sigma limit for the integration which is equal to 2.5 sigmanorm
-  double signormc;     // sigma of the temperature distribution for cloudy day
-  double siglimc=0, siglim0, siglim0c;
-  double tstep, tsint, tint, tstepc;
+  IssmDouble DT = 0.02, sigfac, snormfac;
+  IssmDouble signorm = 5.5;      // signorm : sigma of the temperature distribution for a normal day 
+  IssmDouble siglim;       // sigma limit for the integration which is equal to 2.5 sigmanorm
+  IssmDouble signormc = signorm - 0.5;     // sigma of the temperature distribution for cloudy day
+  IssmDouble siglimc, siglim0, siglim0c;
+  IssmDouble tstep, tsint, tint, tstepc;
   int    NPDMAX = 1504, NPDCMAX = 1454;
-  //double pdds[NPDMAX]={0}; 
-  //double pds[NPDCMAX]={0};
-  double pddt, pd ; // pd : snow/precip fraction, precipitation falling as snow
-  double PDup, PDCUT = 2.0;    // PDcut: rain/snow cutoff temperature (C)
-  double tstar; // monthly mean surface temp
+  //IssmDouble pdds[NPDMAX]={0}; 
+  //IssmDouble pds[NPDCMAX]={0};
+  IssmDouble pddt, pd ; // pd : snow/precip fraction, precipitation falling as snow
+  IssmDouble PDup, PDCUT = 2.0;    // PDcut: rain/snow cutoff temperature (C)
+  IssmDouble tstar; // monthly mean surface temp
   
-  double* pdds=NULL; 
-  double* pds=NULL; 
+  IssmDouble* pdds=NULL; 
+  IssmDouble* pds=NULL; 
   Element* element = NULL;
   
-  pdds=(double*)xmalloc(NPDMAX*sizeof(double)+1); 
-  pds=(double*)xmalloc(NPDCMAX*sizeof(double)+1); 
-  
-  
-  // PDD constant
-  siglim = 2.5*signorm; 
+  pdds=xNew<IssmDouble>(NPDMAX+1); 
+  pds=xNew<IssmDouble>(NPDCMAX+1); 
   
   // initialize PDD (creation of a lookup table)
@@ -53,8 +49,13 @@
   snormfac = 1.0/(signorm*sqrt(2.0*acos(-1.0)));
   siglim = 2.5*signorm;
-  itm = (int)(2*siglim/DT + 1.5);
+  siglimc = 2.5*signormc;
+  siglim0 =  siglim/DT + 0.5;
+  siglim0c =  siglimc/DT + 0.5;
+  PDup = siglimc+PDCUT;
+
+  itm = reCast<int,IssmDouble>((2*siglim/DT + 1.5));
   
   if (itm >= NPDMAX){
-    printf("increase NPDMAX in massBalance.cpp\n");
+    _printLine_("increase NPDMAX in massBalance.cpp");
     exit (1);
       }
@@ -63,5 +64,5 @@
     tstar = it*DT-siglim;
     tint = tsint;
-    pddt = 0;
+    pddt = 0.;
     for ( jj = 0; jj < 600; jj++){
       if (tint > (tstar+siglim)){break;}
@@ -80,7 +81,7 @@
   snormfac = 1.0/(signormc*sqrt(2.0*acos(-1.0)));
   siglimc = 2.5*signormc ;
-  itm = (int)((PDCUT+2.*siglimc)/DT + 1.5);
+  itm = reCast<int,IssmDouble>((PDCUT+2.*siglimc)/DT + 1.5);
   if (itm >= NPDCMAX){
-    printf("'increase NPDCMAX in p35com'\n");
+    _printLine_("'increase NPDCMAX in p35com'");
     exit (1);
       }
@@ -89,5 +90,5 @@
     //    tstar = REAL(it)*DT-siglimc;
     tint = tsint;          // start against upper bound
-    pd = 0;
+    pd = 0.;
     for (jj = 0; jj < 600; jj++){
       if (tint<(tstar-siglimc)) {break;}
@@ -97,5 +98,5 @@
     pds[it] = pd*snormfac;  // gaussian integral lookup table for snow fraction
   }
-  pds[itm+1] = 0;
+  pds[itm+1] = 0.;
   //     *******END initialize PDD
   
@@ -105,6 +106,6 @@
   }
   /*free ressouces: */
-  xfree((void**)&pdds);
-  xfree((void**)&pds);
+  xDelete<IssmDouble>(pdds);
+  xDelete<IssmDouble>(pds);
   
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Reduceloadx/Reduceloadx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Reduceloadx/Reduceloadx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Reduceloadx/Reduceloadx.cpp	(revision 12878)
@@ -22,5 +22,5 @@
 	int         verbose;
 
-	_printf_(VerboseModule(),"   Dirichlet lifting applied to load vector\n");
+	if(VerboseModule()) _pprintLine_("   Dirichlet lifting applied to load vector");
 
 	Kfs->GetSize(&global_m,&global_n);
Index: issm/branches/trunk-jpl-damage/src/c/modules/Reduceloadx/Reduceloadx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Reduceloadx/Reduceloadx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Reduceloadx/Reduceloadx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _REDUCELOADX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.cpp	(revision 12878)
@@ -15,5 +15,5 @@
 	int configuration_type;
 	int fsize;
-	double* ug_serial=NULL;
+	IssmDouble* ug_serial=NULL;
 
 	/*first figure out fsize: */
@@ -51,5 +51,5 @@
 
 	/*Free ressources:*/
-	xfree((void**)&ug_serial);
+	xDelete<IssmDouble>(ug_serial);
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtofx/Reducevectorgtofx.h	(revision 12878)
@@ -7,5 +7,5 @@
 #define _REDUCEVECTORGTOFX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.cpp	(revision 12878)
@@ -51,5 +51,5 @@
 
 	/*Free ressources:*/
-	xfree((void**)&yg_serial);
+	xDelete<double>(yg_serial);
 
 	/*Assign output pointers:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Reducevectorgtosx/Reducevectorgtosx.h	(revision 12878)
@@ -7,5 +7,5 @@
 #define _REDUCEVECTORGTOSX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/RequestedOutputsx/RequestedOutputsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/RequestedOutputsx/RequestedOutputsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/RequestedOutputsx/RequestedOutputsx.cpp	(revision 12878)
@@ -13,6 +13,6 @@
 	int      output_enum;
 	int      step;
-	double   time;
-	double   output_value;
+	IssmDouble   time;
+	IssmDouble   output_value;
 	Element *element      = NULL;
 
@@ -32,4 +32,8 @@
 					results->AddObject(new DoubleExternalResult(results->Size()+1,IceVolumeEnum,output_value,step,time));
 					break;
+				case TotalSmbEnum:
+					Responsex(&output_value,elements,nodes,vertices,loads,materials,parameters,"TotalSmb",false,0);
+					results->AddObject(new DoubleExternalResult(results->Size()+1,TotalSmbEnum,output_value,step,time));
+					break;
 				default:
 					/*create this output in the element inputs, and then transfer to results:*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ResetConstraintsx/ResetConstraintsx.cpp	(revision 12878)
@@ -22,5 +22,5 @@
 
 	/*Display message*/
-	_printf_(VerboseModule(),"   Resetting penalties\n");
+	if(VerboseModule()) _pprintLine_("   Resetting penalties");
 
 	/*recover parameters: */
@@ -30,5 +30,5 @@
 	 * management routine, otherwise, skip : */
 	if (RiftIsPresent(loads,analysis_type)){
-		_error_("rift constraints reset not supported yet!");
+		_error2_("rift constraints reset not supported yet!");
 	}
 	else if(ThermalIsPresent(loads,analysis_type)){
Index: issm/branches/trunk-jpl-damage/src/c/modules/ResetConstraintsx/ResetConstraintsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ResetConstraintsx/ResetConstraintsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ResetConstraintsx/ResetConstraintsx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Responsex/Responsex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Responsex/Responsex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Responsex/Responsex.cpp	(revision 12878)
@@ -16,5 +16,5 @@
 #include "../modules.h"
 
-void Responsex(double* responses,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,const char* response_descriptor,bool process_units,int weight_index){
+void Responsex(IssmDouble* responses,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,const char* response_descriptor,bool process_units,int weight_index){
 
 	switch (StringToEnumx(response_descriptor)){
@@ -41,4 +41,5 @@
 		case ThicknessAbsMisfitEnum:     ThicknessAbsMisfitx(      responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
 		case ThicknessAbsGradientEnum:   ThicknessAbsGradientx(    responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
+		case TotalSmbEnum:					TotalSmbx(                responses, elements,nodes, vertices, loads, materials, parameters,process_units); break;
 		case RheologyBbarAbsGradientEnum:RheologyBbarAbsGradientx( responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
 		case DragCoefficientAbsGradientEnum:DragCoefficientAbsGradientx(responses, elements,nodes, vertices, loads, materials, parameters,process_units,weight_index); break;
@@ -46,7 +47,7 @@
 		case VelEnum:ElementResponsex(responses, elements,nodes, vertices, loads, materials, parameters,VelEnum,process_units); break;
 		case FrictionCoefficientEnum:NodalValuex(responses, FrictionCoefficientEnum,elements,nodes, vertices, loads, materials, parameters,process_units); break;
-		default: _error_(" response descriptor \"%s\" not supported yet!",response_descriptor); break;
+		default: _error2_("response descriptor \"" << response_descriptor << "\" not supported yet!"); break;
 		#else
-		default: _error_(" ISSM was not compiled with responses capabilities, exiting!");
+		default: _error2_("ISSM was not compiled with responses capabilities, exiting!");
 		#endif
 	}
Index: issm/branches/trunk-jpl-damage/src/c/modules/Responsex/Responsex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Responsex/Responsex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Responsex/Responsex.h	(revision 12878)
@@ -6,8 +6,8 @@
 #define _RESPONSESX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
-void Responsex(double* presponse,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,const char* response_descriptor,bool process_units,int weight_index);
+void Responsex(IssmDouble* presponse,Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters,const char* response_descriptor,bool process_units,int weight_index);
 
 #endif  /* _RESPONSESXX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Scotchx/Scotchx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Scotchx/Scotchx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Scotchx/Scotchx.h	(revision 12878)
@@ -20,5 +20,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 #ifdef _HAVE_SCOTCH_ //only works if scotch library has been compiled in.
Index: issm/branches/trunk-jpl-damage/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.cpp	(revision 12878)
@@ -25,5 +25,5 @@
 	}
 
-	xfree((void**)&control_type);
+	xDelete<int>(control_type);
 }
 
@@ -37,4 +37,4 @@
 
 	/*Free ressources:*/
-	xfree((void**)&serial_vector);
+	xDelete<double>(serial_vector);
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/SetControlInputsFromVectorx/SetControlInputsFromVectorx.h	(revision 12878)
@@ -5,5 +5,5 @@
 #define _SETCONTROLINPUTSXFROMVECTOR_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
